#!/usr/bin/perl

# Operaciones lgicas
#
#
# Fraga, 21, mayo, 2004

# Tamao de la imagen
$rows = 100;
$cols = 100;

# Limpio la imagen
for( $i=0; $i<$rows; $i++ ){
	for( $j=0; $j<$cols; $j++ ){
		$imgA[ $i * $cols + $j ] = 1;
		$imgB[ $i * $cols + $j ] = 1;
	}
}
# Ponemos un rectngulo blanco en A
for( $i=30; $i<70; $i++ ){
	for( $j=20; $j<80; $j++ ){
		$imgA[ $i * $cols + $j ] = 0;
	}
}
# Ponemos un cuadrado blanco en el B
for( $i=50; $i<80; $i++ ){
	for( $j=10; $j<40; $j++ ){
		$imgB[ $i * $cols + $j ] = 0;
	}
}

$r = save_pgm_img ( \@imgA, $rows, $cols, "A.pgm" );
$r = save_pgm_img ( \@imgB, $rows, $cols, "B.pgm" );

# NOT
for( $i=0; $i<$rows; $i++ ){
	for( $j=0; $j<$cols; $j++ ){
		$imgC[ $i * $cols + $j ] = !$imgA[ $i * $cols + $j ];
	}
}
$r = save_pgm_img ( \@imgC, $rows, $cols, "notA.pgm" );

# AND
for( $i=0; $i<$rows; $i++ ){
	for( $j=0; $j<$cols; $j++ ){
		$imgC[ $i * $cols + $j ] =
		    $imgA[ $i * $cols + $j ] & $imgB[ $i * $cols + $j ];
	}
}
$r = save_pgm_img ( \@imgC, $rows, $cols, "AandB.pgm" );

# OR
for( $i=0; $i<$rows; $i++ ){
	for( $j=0; $j<$cols; $j++ ){
		$imgC[ $i * $cols + $j ] =
		    $imgA[ $i * $cols + $j ] | $imgB[ $i * $cols + $j ];
	}
}
$r = save_pgm_img ( \@imgC, $rows, $cols, "AorB.pgm" );

# XOR
for( $i=0; $i<$rows; $i++ ){
	for( $j=0; $j<$cols; $j++ ){
		$imgC[ $i * $cols + $j ] =
		    $imgA[ $i * $cols + $j ] ^ $imgB[ $i * $cols + $j ];
	}
}
$r = save_pgm_img ( \@imgC, $rows, $cols, "AxorB.pgm" );


# Subroutine to save an image in raw PGM format
# (see pgm man pages on NETPBM package)
sub save_pgm_img (\@$$$) {  # ( @img, $rows, $cols, $filename );
	local (*myimg) = shift(@_);
	my $myrows = shift(@_);
	my $mycols = shift(@_);
	my $filename = shift(@_);

	my $n = @myimg;
	printf "$n $mycols $myrows $filename\n";

	open ( MYFILE, ">$filename" ) or return 1;

	select MYFILE;
	$| = 1;
	print MYFILE "P5\n";
	print MYFILE "# file: $filename\n";
	print MYFILE "$mycols $myrows\n";
	print MYFILE "255\n";

	my @data;
	for ( my $i=0; $i<$myrows; $i++ ){
		for ( my $j=0; $j<$mycols; $j++ ){
			$data[$j] =  $myimg[ $mycols*$i + $j ] ? 255 : 0; 
		}

		my $bytes = pack( "C$mycols", @data );
		syswrite ( MYFILE, $bytes, $n );
	}

	close MYFILE;
	select STDOUT;
	return 0;
}
