#!/usr/bin/perl

# Perl program to save a PGM image
#
#
# Fraga, April 16, 2001
#      Comments Added, May 14, 2003
#      Comments Added, May 14, 2004

# A test image of size 256x256 pixels
$rows = 256;
$cols = 256;

# Limpio la imagen
for( $i=0; $i<$rows; $i++ ){
	for( $j=0; $j<$cols; $j++ ){
		$imgA[ $i * $cols + $j ] = 0;
	}
}
# Ponemos un cuadrado blanco en el centro
$c=40;
for( $i=$c; $i<$rows-$c; $i++ ){
	for( $j=$c; $j<$cols-$c; $j++ ){
		$imgA[ $i * $cols + $j ] = 255;
	}
}
# $n = @imgA;
# print "n = $n\n";

$r = save_pgm_img ( \@imgA, $rows, $cols, "rampa.pgm" );
if ( $r ) {
	print "Error saving image!\n";
}

# Subroutine to save an image in raw PGM format
# (see pgm man pages on NETPBM package)
sub save_pgm_img (\@$$$) {  # ( @img, $rows, $cols, $filename );
	local (*myimg) = shift(@_);
	my $myrows = shift(@_);
	my $mycols = shift(@_);
	my $filename = shift(@_);

	my $n = @myimg;
	printf "$n $mycols $myrows $filename\n";

	open ( MYFILE, ">$filename" ) or return 1;

	select MYFILE;
	$| = 1;
	print MYFILE "P5\n";
	print MYFILE "# file: $filename\n";
	print MYFILE "$mycols $myrows\n";
	print MYFILE "255\n";

	my @data;
	for ( my $i=0; $i<$myrows; $i++ ){
		for ( my $j=0; $j<$mycols; $j++ ){
			$data[$j] = $myimg[ $mycols*$i + $j ];
		}

		my $bytes = pack( "C$mycols", @data );
		syswrite ( MYFILE, $bytes, $n );
	}

	close MYFILE;
	select STDOUT;
	return 0;
}
