#!/usr/bin/perl

# Perl program to create an image
# of a bidimensional function
#
#
#      Fraga, May 14, 2004

die "Args: n\n" if $#ARGV!=0;

# Periodo de las muestras
$n = $ARGV[0];

# A test image of size 256x256 pixels
$rows = 256;
$cols = 256;

die "ERROR: n debe ser menos a 256\n" if ($n>$cols);

$pi2 = 2*3.141592654;

# Limpio la imagen
for( $i=0; $i<$rows; $i++ ){
	$ii = $i % $n;
	for( $j=0; $j<$cols; $j++ ){
		$jj = $j % $n;
		$f = sin( $ii * $pi2/$n ) * sin( $jj * $pi2/$n );
		$g = int( ($f + 1.0)/2 * 255 + 0.5 ); 
		$imgA[ $i * $cols + $j ] = $g;
	}
}

$r = save_pgm_img ( \@imgA, $rows, $cols, "seno.pgm" );
if ( $r ) {
	print "Error saving image!\n";
}

# Subroutine to save an image in raw PGM format
# (see pgm man pages on NETPBM package)
sub save_pgm_img (\@$$$) {  # ( @img, $rows, $cols, $filename );
	local (*myimg) = shift(@_);
	my $myrows = shift(@_);
	my $mycols = shift(@_);
	my $filename = shift(@_);

	my $n = @myimg;
	printf "$n $mycols $myrows $filename\n";

	open ( MYFILE, ">$filename" ) or return 1;

	select MYFILE;
	$| = 1;
	print MYFILE "P5\n";
	print MYFILE "# file: $filename\n";
	print MYFILE "$mycols $myrows\n";
	print MYFILE "255\n";

	my @data;
	for ( my $i=0; $i<$myrows; $i++ ){
		for ( my $j=0; $j<$mycols; $j++ ){
			$data[$j] = $myimg[ $mycols*$i + $j ];
		}

		my $bytes = pack( "C$mycols", @data );
		syswrite ( MYFILE, $bytes, $n );
	}

	close MYFILE;
	select STDOUT;
	return 0;
}
